# all files / ol/ tileurlfunction.js

100% Statements 53/53
100% Branches 10/10
100% Functions 9/9
100% Lines 53/53

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    1501×
    1×

    1×
    1×
    1×
    1×

    1×

    1×

    1×
    72×
    72×
    72×
    72×
    72×

    51×
    5×

    46×

    38×
    38×

    2×
    2×
    2×

    2×
    2×

    1×
    48×
    48×
    48×
    61×

    48×

    1×
    54×

    54×
    42×

    12×

    19×
    1×

    18×
    18×
    18×

    1×

    1×

    1×
    45×
    45×
    45×
    5×
    5×
    5×
    5×
    15×

    40×

    45×

     goog.provide('ol.TileUrlFunction');
    goog.provide('ol.TileUrlFunctionType');

    goog.require('goog.asserts');
    goog.require('goog.math');
    goog.require('ol.TileCoord');
    goog.require('ol.tilecoord');

    /**
     * {@link ol.source.Tile} sources use a function of this type to get the url
     * that provides a tile for a given tile coordinate.
     *
     * This function takes an {@link ol.TileCoord} for the tile coordinate, a
     * `{number}` representing the pixel ratio and an {@link ol.proj.Projection} for
     * the projection  as arguments and returns a `{string}` representing the tile
     * URL, or undefined if no tile should be requested for the passed tile
     * coordinate.
     *
     * @typedef {function(ol.TileCoord, number,
     *           ol.proj.Projection): (string|undefined)}
     * @api
     */
    ol.TileUrlFunctionType;

    /**
     * @typedef {function(ol.TileCoord, ol.proj.Projection, ol.TileCoord=):
     *     ol.TileCoord}
     */
    ol.TileCoordTransformType;

    /**
     * @param {string} template Template.
     * @param {ol.tilegrid.TileGrid} tileGrid Tile grid.
     * @return {ol.TileUrlFunctionType} Tile URL function.
     */
    ol.TileUrlFunction.createFromTemplate = function(template, tileGrid) {
      var zRegEx = /\{z\}/g;
      var xRegEx = /\{x\}/g;
      var yRegEx = /\{y\}/g;
      var dashYRegEx = /\{-y\}/g;
      return (
          /**
           * @param {ol.TileCoord} tileCoord Tile Coordinate.
           * @param {number} pixelRatio Pixel ratio.
           * @param {ol.proj.Projection} projection Projection.
           * @return {string|undefined} Tile URL.
           */
          function(tileCoord, pixelRatio, projection) {
            if (!tileCoord) {
              return undefined;
            } else {
              return template.replace(zRegEx, tileCoord[0].toString())
                  .replace(xRegEx, tileCoord[1].toString())
                  .replace(yRegEx, function() {
                    var y = -tileCoord[2] - 1;
                    return y.toString();
                  })
                  .replace(dashYRegEx, function() {
                    var z = tileCoord[0];
                    var range = tileGrid.getFullTileRange(z);
                    goog.asserts.assert(range,
                        'The {-y} template requires a tile grid with extent');
                    var y = range.getHeight() + tileCoord[2];
                    return y.toString();
                  });
            }
          });
    };

    /**
     * @param {Array.<string>} templates Templates.
     * @param {ol.tilegrid.TileGrid} tileGrid Tile grid.
     * @return {ol.TileUrlFunctionType} Tile URL function.
     */
    ol.TileUrlFunction.createFromTemplates = function(templates, tileGrid) {
      var len = templates.length;
      var tileUrlFunctions = new Array(len);
      for (var i = 0; i < len; ++i) {
        tileUrlFunctions[i] = ol.TileUrlFunction.createFromTemplate(
            templates[i], tileGrid);
      }
      return ol.TileUrlFunction.createFromTileUrlFunctions(tileUrlFunctions);
    };

    /**
     * @param {Array.<ol.TileUrlFunctionType>} tileUrlFunctions Tile URL Functions.
     * @return {ol.TileUrlFunctionType} Tile URL function.
     */
    ol.TileUrlFunction.createFromTileUrlFunctions = function(tileUrlFunctions) {
      goog.asserts.assert(tileUrlFunctions.length > 0,
          'Length of tile url functions should be greater than 0');
      if (tileUrlFunctions.length === 1) {
        return tileUrlFunctions[0];
      }
      return (
          /**
           * @param {ol.TileCoord} tileCoord Tile Coordinate.
           * @param {number} pixelRatio Pixel ratio.
           * @param {ol.proj.Projection} projection Projection.
           * @return {string|undefined} Tile URL.
           */
          function(tileCoord, pixelRatio, projection) {
            if (!tileCoord) {
              return undefined;
            } else {
              var h = ol.tilecoord.hash(tileCoord);
              var index = goog.math.modulo(h, tileUrlFunctions.length);
              return tileUrlFunctions[index](tileCoord, pixelRatio, projection);
            }
          });
    };

    /**
     * @param {ol.TileCoord} tileCoord Tile coordinate.
     * @param {number} pixelRatio Pixel ratio.
     * @param {ol.proj.Projection} projection Projection.
     * @return {string|undefined} Tile URL.
     */
    ol.TileUrlFunction.nullTileUrlFunction =
        function(tileCoord, pixelRatio, projection) {
      return undefined;
    };

    /**
     * @param {string} url URL.
     * @return {Array.<string>} Array of urls.
     */
    ol.TileUrlFunction.expandUrl = function(url) {
      var urls = [];
      var match = /\{(\d)-(\d)\}/.exec(url) || /\{([a-z])-([a-z])\}/.exec(url);
      if (match) {
        var startCharCode = match[1].charCodeAt(0);
        var stopCharCode = match[2].charCodeAt(0);
        var charCode;
        for (charCode = startCharCode; charCode <= stopCharCode; ++charCode) {
          urls.push(url.replace(match[0], String.fromCharCode(charCode)));
        }
      } else {
        urls.push(url);
      }
      return urls;
    };